# 1 "Int.hs.cpp"
module FFI
  -- all types are abstract and instances of:
  -- Num, Bounded, Real, Integral, Ix, Enum, Read, Show
  ( Int8
  , Int16
  , Int32
  , Int64
  ) where

{- Note explicit braces and semicolons here - layout is corrupted by cpp. -}

{import FFIBuiltin (Int8, Int16, Int32, Int64)
;import Numeric    (readSigned,readDec,showSigned,showIntBase)
;import Ix



# 29 "Int.hs.cpp"


# 47 "Int.hs.cpp"
















# 71 "Int.hs.cpp"















































; ; foreign import primEqInt8  		::   Int8   ->   Int8    -> Bool	; foreign import primLtInt8  		::   Int8   ->   Int8    -> Bool	; foreign import primLeInt8  		::   Int8   ->   Int8    -> Bool	; foreign import primGtInt8  		::   Int8   ->   Int8    -> Bool	; foreign import primGeInt8  		::   Int8   ->   Int8    -> Bool	; foreign import primAddInt8  		::   Int8   ->   Int8    ->   Int8  	; foreign import primSubInt8  		::   Int8   ->   Int8    ->   Int8  	; foreign import primMulInt8  		::   Int8   ->   Int8    ->   Int8  	; foreign import primAbsInt8  		::   Int8         ->   Int8  	; foreign import primSignumInt8  		::   Int8         ->   Int8  	; foreign import primQuotInt8  		::   Int8   ->   Int8    ->   Int8  	; foreign import primRemInt8  		::   Int8   ->   Int8    ->   Int8  	; foreign import primToEnumInt8  		:: Int     ->   Int8  	; foreign import primFromEnumInt8  	::   Int8         -> Int	; foreign import primInt8FromInteger	:: Integer ->   Int8  	; foreign import primInt8ToInteger	::   Int8         -> Integer 	; ; instance Eq   Int8   where	{ (==) = primEqInt8  	} 	; ; instance Ord   Int8   where	{ (<)  = primLtInt8  	; (<=) = primLeInt8  	; (>)  = primGtInt8  	; (>=) = primGeInt8  	} 	; ; instance Num   Int8   where	{ (+) = primAddInt8  	; (-) = primSubInt8  	; (*) = primMulInt8  	; abs = primAbsInt8  	; signum = primSignumInt8  	; fromInteger = primInt8FromInteger } 	; ; instance Bounded   Int8   where	{ minBound = fromInteger   (-128)  	; maxBound = fromInteger   127  	} 	; ; instance Real   Int8   where	{ toRational i = toInteger i % 1	} 	; ; instance Integral   Int8   where	{ quot = primQuotInt8  	; rem  = primRemInt8  	; toInteger = primInt8ToInteger	} 	; ; instance Ix   Int8   where	{ range (m,n) = [m..n]	; index b@(m,n) i	| inRange b i = fromIntegral (i-m)	| True        = error "Ix.index: Index out of range."	; inRange (m,n) i    = m <= i && i <= n	} 	; ; instance Enum   Int8   where	{ toEnum = primToEnumInt8  	; fromEnum = primFromEnumInt8  	; enumFrom n = n : enumFrom (n+1)	; enumFromThen m n = m : enumFromThen n (2*n-m)	} 	; ; instance Read   Int8   where	{ readsPrec p = readSigned readDec	} 	; ; instance Show   Int8   where	{ showsPrec p = showSigned (showIntBase 10) p	}  
; ; foreign import primEqInt16  		::   Int16   ->   Int16    -> Bool	; foreign import primLtInt16  		::   Int16   ->   Int16    -> Bool	; foreign import primLeInt16  		::   Int16   ->   Int16    -> Bool	; foreign import primGtInt16  		::   Int16   ->   Int16    -> Bool	; foreign import primGeInt16  		::   Int16   ->   Int16    -> Bool	; foreign import primAddInt16  		::   Int16   ->   Int16    ->   Int16  	; foreign import primSubInt16  		::   Int16   ->   Int16    ->   Int16  	; foreign import primMulInt16  		::   Int16   ->   Int16    ->   Int16  	; foreign import primAbsInt16  		::   Int16         ->   Int16  	; foreign import primSignumInt16  		::   Int16         ->   Int16  	; foreign import primQuotInt16  		::   Int16   ->   Int16    ->   Int16  	; foreign import primRemInt16  		::   Int16   ->   Int16    ->   Int16  	; foreign import primToEnumInt16  		:: Int     ->   Int16  	; foreign import primFromEnumInt16  	::   Int16         -> Int	; foreign import primInt16FromInteger	:: Integer ->   Int16  	; foreign import primInt16ToInteger	::   Int16         -> Integer 	; ; instance Eq   Int16   where	{ (==) = primEqInt16  	} 	; ; instance Ord   Int16   where	{ (<)  = primLtInt16  	; (<=) = primLeInt16  	; (>)  = primGtInt16  	; (>=) = primGeInt16  	} 	; ; instance Num   Int16   where	{ (+) = primAddInt16  	; (-) = primSubInt16  	; (*) = primMulInt16  	; abs = primAbsInt16  	; signum = primSignumInt16  	; fromInteger = primInt16FromInteger } 	; ; instance Bounded   Int16   where	{ minBound = fromInteger   (-32768)  	; maxBound = fromInteger   32767  	} 	; ; instance Real   Int16   where	{ toRational i = toInteger i % 1	} 	; ; instance Integral   Int16   where	{ quot = primQuotInt16  	; rem  = primRemInt16  	; toInteger = primInt16ToInteger	} 	; ; instance Ix   Int16   where	{ range (m,n) = [m..n]	; index b@(m,n) i	| inRange b i = fromIntegral (i-m)	| True        = error "Ix.index: Index out of range."	; inRange (m,n) i    = m <= i && i <= n	} 	; ; instance Enum   Int16   where	{ toEnum = primToEnumInt16  	; fromEnum = primFromEnumInt16  	; enumFrom n = n : enumFrom (n+1)	; enumFromThen m n = m : enumFromThen n (2*n-m)	} 	; ; instance Read   Int16   where	{ readsPrec p = readSigned readDec	} 	; ; instance Show   Int16   where	{ showsPrec p = showSigned (showIntBase 10) p	}  
; ; foreign import primEqInt32  		::   Int32   ->   Int32    -> Bool	; foreign import primLtInt32  		::   Int32   ->   Int32    -> Bool	; foreign import primLeInt32  		::   Int32   ->   Int32    -> Bool	; foreign import primGtInt32  		::   Int32   ->   Int32    -> Bool	; foreign import primGeInt32  		::   Int32   ->   Int32    -> Bool	; foreign import primAddInt32  		::   Int32   ->   Int32    ->   Int32  	; foreign import primSubInt32  		::   Int32   ->   Int32    ->   Int32  	; foreign import primMulInt32  		::   Int32   ->   Int32    ->   Int32  	; foreign import primAbsInt32  		::   Int32         ->   Int32  	; foreign import primSignumInt32  		::   Int32         ->   Int32  	; foreign import primQuotInt32  		::   Int32   ->   Int32    ->   Int32  	; foreign import primRemInt32  		::   Int32   ->   Int32    ->   Int32  	; foreign import primToEnumInt32  		:: Int     ->   Int32  	; foreign import primFromEnumInt32  	::   Int32         -> Int	; foreign import primInt32FromInteger	:: Integer ->   Int32  	; foreign import primInt32ToInteger	::   Int32         -> Integer 	; ; instance Eq   Int32   where	{ (==) = primEqInt32  	} 	; ; instance Ord   Int32   where	{ (<)  = primLtInt32  	; (<=) = primLeInt32  	; (>)  = primGtInt32  	; (>=) = primGeInt32  	} 	; ; instance Num   Int32   where	{ (+) = primAddInt32  	; (-) = primSubInt32  	; (*) = primMulInt32  	; abs = primAbsInt32  	; signum = primSignumInt32  	; fromInteger = primInt32FromInteger } 	; ; instance Bounded   Int32   where	{ minBound = fromInteger   (-2147483648)  	; maxBound = fromInteger   2147483647  	} 	; ; instance Real   Int32   where	{ toRational i = toInteger i % 1	} 	; ; instance Integral   Int32   where	{ quot = primQuotInt32  	; rem  = primRemInt32  	; toInteger = primInt32ToInteger	} 	; ; instance Ix   Int32   where	{ range (m,n) = [m..n]	; index b@(m,n) i	| inRange b i = fromIntegral (i-m)	| True        = error "Ix.index: Index out of range."	; inRange (m,n) i    = m <= i && i <= n	} 	; ; instance Enum   Int32   where	{ toEnum = primToEnumInt32  	; fromEnum = primFromEnumInt32  	; enumFrom n = n : enumFrom (n+1)	; enumFromThen m n = m : enumFromThen n (2*n-m)	} 	; ; instance Read   Int32   where	{ readsPrec p = readSigned readDec	} 	; ; instance Show   Int32   where	{ showsPrec p = showSigned (showIntBase 10) p	}  
; ; foreign import primEqInt64  		::   Int64   ->   Int64    -> Bool	; foreign import primLtInt64  		::   Int64   ->   Int64    -> Bool	; foreign import primLeInt64  		::   Int64   ->   Int64    -> Bool	; foreign import primGtInt64  		::   Int64   ->   Int64    -> Bool	; foreign import primGeInt64  		::   Int64   ->   Int64    -> Bool	; foreign import primAddInt64  		::   Int64   ->   Int64    ->   Int64  	; foreign import primSubInt64  		::   Int64   ->   Int64    ->   Int64  	; foreign import primMulInt64  		::   Int64   ->   Int64    ->   Int64  	; foreign import primAbsInt64  		::   Int64         ->   Int64  	; foreign import primSignumInt64  		::   Int64         ->   Int64  	; foreign import primQuotInt64  		::   Int64   ->   Int64    ->   Int64  	; foreign import primRemInt64  		::   Int64   ->   Int64    ->   Int64  	; foreign import primToEnumInt64  		:: Int     ->   Int64  	; foreign import primFromEnumInt64  	::   Int64         -> Int	; foreign import primInt64FromInteger	:: Integer ->   Int64  	; foreign import primInt64ToInteger	::   Int64         -> Integer 	; ; instance Eq   Int64   where	{ (==) = primEqInt64  	} 	; ; instance Ord   Int64   where	{ (<)  = primLtInt64  	; (<=) = primLeInt64  	; (>)  = primGtInt64  	; (>=) = primGeInt64  	} 	; ; instance Num   Int64   where	{ (+) = primAddInt64  	; (-) = primSubInt64  	; (*) = primMulInt64  	; abs = primAbsInt64  	; signum = primSignumInt64  	; fromInteger = primInt64FromInteger } 	; ; instance Bounded   Int64   where	{ minBound = fromInteger   (-9223372036854775808)  	; maxBound = fromInteger   9223372036854775807  	} 	; ; instance Real   Int64   where	{ toRational i = toInteger i % 1	} 	; ; instance Integral   Int64   where	{ quot = primQuotInt64  	; rem  = primRemInt64  	; toInteger = primInt64ToInteger	} 	; ; instance Ix   Int64   where	{ range (m,n) = [m..n]	; index b@(m,n) i	| inRange b i = fromIntegral (i-m)	| True        = error "Ix.index: Index out of range."	; inRange (m,n) i    = m <= i && i <= n	} 	; ; instance Enum   Int64   where	{ toEnum = primToEnumInt64  	; fromEnum = primFromEnumInt64  	; enumFrom n = n : enumFrom (n+1)	; enumFromThen m n = m : enumFromThen n (2*n-m)	} 	; ; instance Read   Int64   where	{ readsPrec p = readSigned readDec	} 	; ; instance Show   Int64   where	{ showsPrec p = showSigned (showIntBase 10) p	}  

}
