typedef struct hashelement *HashPtr;

typedef struct hashelement {
  unsigned long value;
  HashPtr next; // Array of all arguments
} HashElement;

typedef struct {
  HashPtr* hashArray;
  unsigned long size;
  unsigned long count;
} HashTable;

HashElement* newHashElement(unsigned long size) {
  HashElement* e = (HashElement*) malloc(1,sizeof(HashElement));
  e->value = size;
  e->next = NULL;
}

HashTable* newHashTable(unsigned long size) {
  HashTable* h = (HashTable*) malloc(1,sizeof(HashTable));
  h->hashArray = (HashElement**) calloc(size,sizeof(HashElement*));
  h->size = size;
  h->count = 0;
}

void addToHashTable(HashTable* h,unsigned long value) {
  unsigned long hash = value % h->size;
  HashElement* e = newHashElement(value);
  e->next = h->hashArray[hash];
  h->hashArray[hash]=e;
  h->count++;
}

int isInHashTable(HashTable* h,unsigned long value) {
  unsigned long hash = value % h->size;
  HashElement *e = h->hashArray[hash];
  while ((e!=NULL)&&(e->value!=value)) e=e->next;
  return (e!=NULL);
}








